#! /usr/bin/env python
#
#     Copyright (C) 2005 Ronan Keegan
#
#     This code is distributed under the terms and conditions of the
#     CCP4 Program Suite Licence Agreement as a CCP4 Application.
#     A copy of the CCP4 licence can be obtained by writing to the
#     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
#
#
#
# A wrapper to Tcoffee, the multiple alignment program
# Ronan Keegan 13/9/05

import os, sys, string


class T_coffee:
 
   def __init__(self):

      self.t_coffee_EXE = 't_coffee'

      self.input_fasta_file = ''
      self.output_fasta_file = ''
      self.log_file = ''
      try:
         self.debug=eval(os.environ['MRBUMP_DEBUG'])
      except:
         self.debug=False

   def setDEBUG(self, flag):
      self.debug=flag  

   def setInputFastaFile(self, file_name):
      self.input_fasta_file = file_name

   def setOutputFastaFile(self, file_name):
      self.output_fasta_file = file_name

   def setLogFile(self, file_name):
      self.log_file = file_name

   def T_coffee(self, input_fasta_file, output_fasta_file):

      self.setInputFastaFile(input_fasta_file)
      self.setOutputFastaFile(output_fasta_file)
      self.setLogFile('t_coffee.log')

      if self.debug:
         print ""
         print "======================"
         print "Tcoffee command line:"
         print "======================"
         print self.t_coffee_EXE + ' -outorder=input -output=fasta -infile=' + self.input_fasta_file + \
             ' -outfile=' + self.output_fasta_file, 'r'
         print ""

      c=os.popen(self.t_coffee_EXE + ' -outorder=input -output=fasta -infile=' + self.input_fasta_file + \
             ' -outfile=' + self.output_fasta_file, 'r')
      c.close()
      
   def convert_to_fasta(self):
  
      infile=open(self.output_fasta_file,'r')
      
      line=infile.readline()
      while line: 
         print line

         line=infile.readline()
   
   def get_raw_target_len(self):
      ''' A function to get the length of the target sequence before it is processed by the alignment program. '''

      seq = ''
 
      file = open(self.input_fasta_file, 'r')

      line = file.readline()
      name=string.strip(line).replace('>','') 
      line = file.readline()
      while line:
         if '>' in line:
            break
         else:
           seq = seq + string.strip(line)
         line = file.readline()
    
      return len(seq)
         
  
if __name__ == '__main__':

   t_coffee=T_coffee()
   t_coffee.T_coffee('input/1vrd_all.fasta', 'out_1vrd.fasta')



