#! /usr/bin/env python
#
#     Copyright (C) 2005 Ronan Keegan
#
#     This code is distributed under the terms and conditions of the
#     CCP4 Program Suite Licence Agreement as a CCP4 Application.
#     A copy of the CCP4 licence can be obtained by writing to the
#     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
#
# Get_MR_sum.py
#
# Script to extract Summary scores from molrep log
# Ronan Keegan 22/12/05

import string


class MR_Summary:
   """ A class to extract the summary of solutions from an MR log file. """

   def __init__(self):
      self.molrep_summary=''
      self.phaser_summary=''
      self.refmac_summary=''

   def get_molrep_summary(self, logfile):
      """ Get the solution summary molrep log file. """

      f=open(logfile,'r')
   
      line=f.readline()
      while line: 
         if "--- Summary ---" in line:
            line = f.readline()
            line = f.readline()
            self.molrep_summary = line
            line = f.readline()
            for i in range(100):
               self.molrep_summary += line
               line = f.readline()
               if "S__" not in line:
                  break
         line=f.readline()

      f.close()
     
      self.molrep_summary = string.strip(self.molrep_summary)

   def get_phaser_summary(self, logfile):
      """ Get the solution summary phaser log file. """

      f=open(logfile,'r')
   
      line=f.readline()
      while line: 
         if "FINAL SELECTION" in line:
            line = f.readline()
            line = f.readline()
            line = f.readline()
            self.phaser_summary = line
            for i in range(100):
               line = f.readline()
               if "************" in line:
                  break
               else:
                  self.phaser_summary += line
         line=f.readline()

      f.close()

      self.phaser_summary = string.rstrip(self.phaser_summary)

   def get_refmac_summary(self, logfile):
      """ Get the solution summary refmac log file. """

      f=open(logfile,'r')
   
      line=f.readline()
      while line: 
         if "Ncyc   Rfact   Rfree     FOM         LLG  rmsBOND  rmsANGLE rmsCHIRAL" in line:
            self.refmac_summary = line.replace("$$","")
            self.refmac_summary += "\n" 
            line = f.readline()
            for i in range(100):
               line = f.readline()
               if "$$" in line:
                  break
               else:
                  self.refmac_summary += line
         line=f.readline()

      f.close()

      self.refmac_summary = string.rstrip(self.refmac_summary)

#if __name__=='__main__':
#
#   s=MR_Summary()
#   s.get_molrep_summary('molrep.log')
#   print s.molrep_summary

#if __name__=='__main__':
#
#   s=MR_Summary()
#   s.get_phaser_summary('phaser.sum')
#   print s.phaser_summary

if __name__=='__main__':

   s=MR_Summary()
   s.get_refmac_summary('refmac.log')
   print s.refmac_summary

